import {NextFunction, Response} from 'express'
import {JWTRequest} from "../types/JWTRequest";

const getUser = (req: JWTRequest, res: Response, next: NextFunction) => {

    // 检测有无 authorization
    if (!req.headers.authorization) {
        return res.status(401).send({
            'message': 'Unauthorized with no authorization header.'
        })
    }


    // 从 header 中获取 token


    const token = req.headers.authorization.split(' ')[1]

    // 获取 JWT 的用户部分
    const base64Url = token.split('.')[1]
    const base64 = base64Url.replace('-', '+').replace('_', '/')

    req.auth = Object.assign({}, req.auth, JSON.parse(Buffer.from(base64, 'base64').toString()))

    next()
}

// function hasRole(role: string) {
//   return (req: JWTRequest, res: Response, next: NextFunction) => {
//     if (req.user.role === role) {
//       next()
//     } else {
//       res.status(403).send('Unauthorized')
//     }
//   }
// }

export {
    // hasRole,
    getUser
}